Index: resources/styles/default/lines
===================================================================
--- resources/styles/default/lines	(revision 1328)
+++ resources/styles/default/lines	(working copy)
@@ -16,9 +16,9 @@
 
 # Set highway names to include the reference if there is one
 highway=motorway {name '${ref|highway-symbol:hbox} ${name}' | '${ref|highway-symbol:hbox}' | '${name}' }
-highway=trunk {name '${ref|highway-symbol:hbox} ${name}' | '${ref|highway-symbol:hbox}' | '${name}' }
-highway=primary {name '${ref|highway-symbol:box} ${name}' | '${ref|highway-symbol:box}' | '${name}' }
-highway=secondary {name '${ref|highway-symbol:oval} ${name}' | '${ref|highway-symbol:oval}' | '${name}' }
+highway=trunk {name '${ref|highway-symbol:hbox} ${name}' | '${ref|highway-symbol:hbox}' | '${name}'; add display_name = '${name} (${ref})' }
+highway=primary {name '${ref|highway-symbol:box} ${name}' | '${ref|highway-symbol:box}' | '${name}'; add display_name = '${name} (${ref})' }
+highway=secondary {name '${ref|highway-symbol:oval} ${name}' | '${ref|highway-symbol:oval}' | '${name}'; add display_name = '${name} (${ref})' }
 highway=* {name '${ref} ${name}' | '${ref}' | '${name}' }
 
 junction=roundabout & highway=trunk [0x0c road_class=3 road_speed=5 resolution 16]
Index: src/uk/me/parabola/mkgmap/osmstyle/StyledConverter.java
===================================================================
--- src/uk/me/parabola/mkgmap/osmstyle/StyledConverter.java	(revision 1328)
+++ src/uk/me/parabola/mkgmap/osmstyle/StyledConverter.java	(working copy)
@@ -459,6 +459,17 @@
 	private void elementSetup(MapElement ms, GType gt, Element element) {
 		String name = element.getName();
 		String refs = combineRefs(element);
+		
+		// Insert display_name as first ref.
+		// This causes display_name to be displayed in routing 
+		// directions, instead of only the ref.
+		String displayName = element.getTag("display_name");
+
+		if (displayName != null) {
+			if (refs == null) { refs = displayName; } 
+			else { refs = displayName + ";" + refs; }
+		}      
+
 		if(name == null && refs != null) {
 			// use first ref as name
 			name = refs.split(";")[0].trim();
